#!/usr/bin/env luajit

--[[
git clone https://github.com/jaakkopasanen/AutoEq
cd AutoEq
mkdir preset
./convert_autoeq.lua
# look in preset/ folder
]]

local f = io.open('results/README.md', 'r')

local bad = {}
bad['64 Audio Nio (m20 Apex module)'] = '64 Audio Nio (m20 Apex module) (sample 2)'
bad['Audeze LCD-X (worn earpads)'] = 'Audeze LCD-X (worn earpads) (sample 2)'
bad['BQEYZ Spring 1 (mesh mod)'] = 'BQEYZ Spring 1 (mesh mod) (sample 2)'

bad['JQ Hua Jiang'] = 'JQ Hua Jiang (sample 2)'
bad['Noble Audio Khan'] = 'Noble Audio Khan (sample 1)'
bad['qdc Dmagic'] = 'qdc Dmagic (sample 2)'
bad['Sennheiser HD 600 (semi-worn earpads)'] = 'Sennheiser HD 600 (semi-worn earpads) (sample 2)'
bad['Ultimate Ears Live'] = 'Ultimate Ears Live (sample 2)'

local function yeet(path, name)
    local f = io.open(path, 'r')
    assert(f, path)
    local m = '(%-?%d+%.?%d*)'
    local s = {}
    local function ins(v) s[#s + 1] = v; end
    ins'return {\n'
    for line in f:lines() do
        local preamp = string.match(line, 'Preamp%: '..m..' dB')
        ins'    {'
        if preamp then
            ins('name = "preamp", gain = '..preamp..'')
        else
            local kind2name = {PK = 'eq'}
            local kind, fc, gain, q = string.match(line, 'Filter %d+%: ON (.+) Fc '..m..' Hz Gain '..m..' dB Q '..m)
            kind = assert(kind2name[kind], kind)
            ins('name = "'..kind..'", gain = '..gain..', frequency = '..fc..', Q = '..q)
        end
        ins'},\n'
    end
    ins'}\n'
    f:close()

    local f = io.open('preset/'..name..'.lua', 'w')
    f:write(table.concat(s))
    f:close()
end

for line in f:lines() do
    local txt, url = string.match(line, '^%- %[(.*)%]%((.*)%/[^/]*%)$')
    txt = bad[txt] or txt
    if url then
        yeet('results/'..url..'/'..txt..'/'..txt..' ParametricEQ.txt', txt)
    end
end

f:close()
